var env = process.env.NODE_ENV || 'development'; 
var cfg = require('../../config/config.js').get(env);

module.exports = function (app) {
    var getMembershipCtrl = app.modules.membercard.getMembershipCtrl;
    var postMembershipCtrl = app.modules.membercard.postMembershipCtrl;

    app.get(cfg.service.CMF.GET_CustomerMembership_URL[0],
        getMembershipCtrl.getMembership
    );

    app.get(cfg.service.CMF.GET_CustomerMembership_URL[1],
        getMembershipCtrl.getMembership
    );

    app.get(cfg.service.CMF.GET_CustomerMembership_URL[2],
        getMembershipCtrl.getMembership
    );

    app.post(cfg.service.CMF.POST_CustomerMembership_URL[0],
        postMembershipCtrl.postMembership
    );

    app.post(cfg.service.CMF.POST_CustomerMembership_URL[1],
        postMembershipCtrl.postMembership
    );


    
};
