'use strict';
var logger = require('./SutisLogSummary');
var detail ={};
var nodeName = 'SRFP-Genesis';
var dateFormat = require('dateformat');
// var dateFMT = 'l';
var dateFMT = 'yyyymmdd HH:MM:ss.l';

function dateTimeReq(dateFMT) {
    var date = new Date();
    var dateMs = 'l';
    var dateFor = dateFormat(date, dateFMT);
    var dateForms = dateFormat(date, dateMs);
    return [dateFor, dateForms]
}

function dateTimeRes(dateFMT) {
    // var time = new Date();
    // var dateTime = formatDate(new Date(), dateFMT)
    // return [dateTime,time.getTime()];
    
    var date = new Date();
    var dateMs = 'l';
    var dateFor = dateFormat(date, dateFMT);
    var dateForms = dateFormat(date, dateMs);
    return [dateFor, dateForms]
}

detail.write=function(req, cmd, size, mtime){
    var requestTime = dateTimeReq(dateFMT);
    var responseTime = dateTimeRes(dateFMT);
    var processTime = parseInt(responseTime[1]-requestTime[1]);
    
    var appDetail = '{'+
        '"' + nodeName + '.Details' + '":{' +
        '"Session":"'+ req.query.commandId +'",' +
        '"Scenario":"'+ cmd +'",' +
        '"Identity":"",' +
        '"InputTimeStamp":"'+ requestTime[0] +'",' +
        '"Input":' + '[' +
            '{'+
            '"Event":"'+ nodeName +'.'+ cmd +'",' +
            '"Type":"REQ",' +
            '"RawData":"' + req.protocol + '://' + req.get('host') + req.originalUrl +'",' +
            '"Data":' + '{'+
                '"Name":"'+ req.query.name + '",' +
                '"Type":"'+ req.query.type + '",' +
                '"CommandId":"'+ req.query.commandId + '"' +
            '}' +
            '}'+
        '],'+
        '"OutputTimeStamp":"'+ responseTime[0] +'",' +
        '"Output":' + '[' +
            '{'+
            '"Event":"'+ nodeName +'.'+ cmd +'",' +
            '"Type":"' + 'RES",' +
            '"RawData":"'+ req.query.name +'",' +
            '"Data":' + '{'+
                '"Size":"'+ size + '",' +
                '"Modified":"'+ mtime + '"' +
                '}' +
            '}'+
        '],'+
        '"ProcessingTime":"'+ processTime +' ms"' +
        '}' +
    '}'
    logger.detail(appDetail);
};

module.exports = detail;
